// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: GpsAggregating.proto

package ru.omnicomm.pegasus.messaging.settings.location;

public final class GpsAggregatingSettingsParser {
  private GpsAggregatingSettingsParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public static final class GpsAggregatingSettings extends
      com.google.protobuf.GeneratedMessage {
    // Use GpsAggregatingSettings.newBuilder() to construct.
    private GpsAggregatingSettings() {
      initFields();
    }
    private GpsAggregatingSettings(boolean noInit) {}
    
    private static final GpsAggregatingSettings defaultInstance;
    public static GpsAggregatingSettings getDefaultInstance() {
      return defaultInstance;
    }
    
    public GpsAggregatingSettings getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingSettings_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingSettings_fieldAccessorTable;
    }
    
    // required int32 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private boolean hasSourceId;
    private int sourceId_ = 0;
    public boolean hasSourceId() { return hasSourceId; }
    public int getSourceId() { return sourceId_; }
    
    // optional int32 messageType = 2 [default = 520];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 520;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // required int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private boolean hasMessageTime;
    private int messageTime_ = 0;
    public boolean hasMessageTime() { return hasMessageTime; }
    public int getMessageTime() { return messageTime_; }
    
    // optional int32 idleMax = 101 [default = 480];
    public static final int IDLEMAX_FIELD_NUMBER = 101;
    private boolean hasIdleMax;
    private int idleMax_ = 480;
    public boolean hasIdleMax() { return hasIdleMax; }
    public int getIdleMax() { return idleMax_; }
    
    // optional int32 aggrInterval = 102 [default = 600];
    public static final int AGGRINTERVAL_FIELD_NUMBER = 102;
    private boolean hasAggrInterval;
    private int aggrInterval_ = 600;
    public boolean hasAggrInterval() { return hasAggrInterval; }
    public int getAggrInterval() { return aggrInterval_; }
    
    private void initFields() {
    }
    public final boolean isInitialized() {
      if (!hasSourceId) return false;
      if (!hasMessageTime) return false;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasSourceId()) {
        output.writeInt32(1, getSourceId());
      }
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasMessageTime()) {
        output.writeInt32(3, getMessageTime());
      }
      if (hasIdleMax()) {
        output.writeInt32(101, getIdleMax());
      }
      if (hasAggrInterval()) {
        output.writeInt32(102, getAggrInterval());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasSourceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, getSourceId());
      }
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasMessageTime()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, getMessageTime());
      }
      if (hasIdleMax()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(101, getIdleMax());
      }
      if (hasAggrInterval()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(102, getAggrInterval());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings result;
      
      // Construct using ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings other) {
        if (other == ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasIdleMax()) {
          setIdleMax(other.getIdleMax());
        }
        if (other.hasAggrInterval()) {
          setAggrInterval(other.getAggrInterval());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 8: {
              setSourceId(input.readInt32());
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 24: {
              setMessageTime(input.readInt32());
              break;
            }
            case 808: {
              setIdleMax(input.readInt32());
              break;
            }
            case 816: {
              setAggrInterval(input.readInt32());
              break;
            }
          }
        }
      }
      
      
      // required int32 sourceId = 1;
      public boolean hasSourceId() {
        return result.hasSourceId();
      }
      public int getSourceId() {
        return result.getSourceId();
      }
      public Builder setSourceId(int value) {
        result.hasSourceId = true;
        result.sourceId_ = value;
        return this;
      }
      public Builder clearSourceId() {
        result.hasSourceId = false;
        result.sourceId_ = 0;
        return this;
      }
      
      // optional int32 messageType = 2 [default = 520];
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 520;
        return this;
      }
      
      // required int32 messageTime = 3;
      public boolean hasMessageTime() {
        return result.hasMessageTime();
      }
      public int getMessageTime() {
        return result.getMessageTime();
      }
      public Builder setMessageTime(int value) {
        result.hasMessageTime = true;
        result.messageTime_ = value;
        return this;
      }
      public Builder clearMessageTime() {
        result.hasMessageTime = false;
        result.messageTime_ = 0;
        return this;
      }
      
      // optional int32 idleMax = 101 [default = 480];
      public boolean hasIdleMax() {
        return result.hasIdleMax();
      }
      public int getIdleMax() {
        return result.getIdleMax();
      }
      public Builder setIdleMax(int value) {
        result.hasIdleMax = true;
        result.idleMax_ = value;
        return this;
      }
      public Builder clearIdleMax() {
        result.hasIdleMax = false;
        result.idleMax_ = 480;
        return this;
      }
      
      // optional int32 aggrInterval = 102 [default = 600];
      public boolean hasAggrInterval() {
        return result.hasAggrInterval();
      }
      public int getAggrInterval() {
        return result.getAggrInterval();
      }
      public Builder setAggrInterval(int value) {
        result.hasAggrInterval = true;
        result.aggrInterval_ = value;
        return this;
      }
      public Builder clearAggrInterval() {
        result.hasAggrInterval = false;
        result.aggrInterval_ = 600;
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettings)
    }
    
    static {
      defaultInstance = new GpsAggregatingSettings(true);
      ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettings)
  }
  
  public static final class GpsAggregatingBuffer extends
      com.google.protobuf.GeneratedMessage {
    // Use GpsAggregatingBuffer.newBuilder() to construct.
    private GpsAggregatingBuffer() {
      initFields();
    }
    private GpsAggregatingBuffer(boolean noInit) {}
    
    private static final GpsAggregatingBuffer defaultInstance;
    public static GpsAggregatingBuffer getDefaultInstance() {
      return defaultInstance;
    }
    
    public GpsAggregatingBuffer getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_fieldAccessorTable;
    }
    
    public static final class GpsData extends
        com.google.protobuf.GeneratedMessage {
      // Use GpsData.newBuilder() to construct.
      private GpsData() {
        initFields();
      }
      private GpsData(boolean noInit) {}
      
      private static final GpsData defaultInstance;
      public static GpsData getDefaultInstance() {
        return defaultInstance;
      }
      
      public GpsData getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_GpsData_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_GpsData_fieldAccessorTable;
      }
      
      // optional int32 dataId = 1;
      public static final int DATAID_FIELD_NUMBER = 1;
      private boolean hasDataId;
      private int dataId_ = 0;
      public boolean hasDataId() { return hasDataId; }
      public int getDataId() { return dataId_; }
      
      // optional double latitude = 2;
      public static final int LATITUDE_FIELD_NUMBER = 2;
      private boolean hasLatitude;
      private double latitude_ = 0D;
      public boolean hasLatitude() { return hasLatitude; }
      public double getLatitude() { return latitude_; }
      
      // optional double longitude = 3;
      public static final int LONGITUDE_FIELD_NUMBER = 3;
      private boolean hasLongitude;
      private double longitude_ = 0D;
      public boolean hasLongitude() { return hasLongitude; }
      public double getLongitude() { return longitude_; }
      
      private void initFields() {
      }
      public final boolean isInitialized() {
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (hasDataId()) {
          output.writeInt32(1, getDataId());
        }
        if (hasLatitude()) {
          output.writeDouble(2, getLatitude());
        }
        if (hasLongitude()) {
          output.writeDouble(3, getLongitude());
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (hasDataId()) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(1, getDataId());
        }
        if (hasLatitude()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(2, getLatitude());
        }
        if (hasLongitude()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(3, getLongitude());
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> {
        private ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData result;
        
        // Construct using ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.newBuilder()
        private Builder() {}
        
        private static Builder create() {
          Builder builder = new Builder();
          builder.result = new ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData();
          return builder;
        }
        
        protected ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData internalGetResult() {
          return result;
        }
        
        public Builder clear() {
          if (result == null) {
            throw new IllegalStateException(
              "Cannot call clear() after build().");
          }
          result = new ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData();
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(result);
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.getDefaultInstance();
        }
        
        public boolean isInitialized() {
          return result.isInitialized();
        }
        public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData build() {
          if (result != null && !isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return buildPartial();
        }
        
        private ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          if (!isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return buildPartial();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData buildPartial() {
          if (result == null) {
            throw new IllegalStateException(
              "build() has already been called on this Builder.");
          }
          ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData returnMe = result;
          result = null;
          return returnMe;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData other) {
          if (other == ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.getDefaultInstance()) return this;
          if (other.hasDataId()) {
            setDataId(other.getDataId());
          }
          if (other.hasLatitude()) {
            setLatitude(other.getLatitude());
          }
          if (other.hasLongitude()) {
            setLongitude(other.getLongitude());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  return this;
                }
                break;
              }
              case 8: {
                setDataId(input.readInt32());
                break;
              }
              case 17: {
                setLatitude(input.readDouble());
                break;
              }
              case 25: {
                setLongitude(input.readDouble());
                break;
              }
            }
          }
        }
        
        
        // optional int32 dataId = 1;
        public boolean hasDataId() {
          return result.hasDataId();
        }
        public int getDataId() {
          return result.getDataId();
        }
        public Builder setDataId(int value) {
          result.hasDataId = true;
          result.dataId_ = value;
          return this;
        }
        public Builder clearDataId() {
          result.hasDataId = false;
          result.dataId_ = 0;
          return this;
        }
        
        // optional double latitude = 2;
        public boolean hasLatitude() {
          return result.hasLatitude();
        }
        public double getLatitude() {
          return result.getLatitude();
        }
        public Builder setLatitude(double value) {
          result.hasLatitude = true;
          result.latitude_ = value;
          return this;
        }
        public Builder clearLatitude() {
          result.hasLatitude = false;
          result.latitude_ = 0D;
          return this;
        }
        
        // optional double longitude = 3;
        public boolean hasLongitude() {
          return result.hasLongitude();
        }
        public double getLongitude() {
          return result.getLongitude();
        }
        public Builder setLongitude(double value) {
          result.hasLongitude = true;
          result.longitude_ = value;
          return this;
        }
        public Builder clearLongitude() {
          result.hasLongitude = false;
          result.longitude_ = 0D;
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingBuffer.GpsData)
      }
      
      static {
        defaultInstance = new GpsData(true);
        ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.internalForceInit();
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingBuffer.GpsData)
    }
    
    // required int32 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private boolean hasSourceId;
    private int sourceId_ = 0;
    public boolean hasSourceId() { return hasSourceId; }
    public int getSourceId() { return sourceId_; }
    
    // optional int32 messageType = 2 [default = 521];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 521;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // required int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private boolean hasMessageTime;
    private int messageTime_ = 0;
    public boolean hasMessageTime() { return hasMessageTime; }
    public int getMessageTime() { return messageTime_; }
    
    // optional int32 idleMax = 101;
    public static final int IDLEMAX_FIELD_NUMBER = 101;
    private boolean hasIdleMax;
    private int idleMax_ = 0;
    public boolean hasIdleMax() { return hasIdleMax; }
    public int getIdleMax() { return idleMax_; }
    
    // optional int32 aggrInterval = 102;
    public static final int AGGRINTERVAL_FIELD_NUMBER = 102;
    private boolean hasAggrInterval;
    private int aggrInterval_ = 0;
    public boolean hasAggrInterval() { return hasAggrInterval; }
    public int getAggrInterval() { return aggrInterval_; }
    
    // repeated .ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingBuffer.GpsData buffer = 103;
    public static final int BUFFER_FIELD_NUMBER = 103;
    private java.util.List<ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData> buffer_ =
      java.util.Collections.emptyList();
    public java.util.List<ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData> getBufferList() {
      return buffer_;
    }
    public int getBufferCount() { return buffer_.size(); }
    public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData getBuffer(int index) {
      return buffer_.get(index);
    }
    
    // optional .ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingBuffer.GpsData concentratedMassCenter = 104;
    public static final int CONCENTRATEDMASSCENTER_FIELD_NUMBER = 104;
    private boolean hasConcentratedMassCenter;
    private ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData concentratedMassCenter_;
    public boolean hasConcentratedMassCenter() { return hasConcentratedMassCenter; }
    public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData getConcentratedMassCenter() { return concentratedMassCenter_; }
    
    private void initFields() {
      concentratedMassCenter_ = ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.getDefaultInstance();
    }
    public final boolean isInitialized() {
      if (!hasSourceId) return false;
      if (!hasMessageTime) return false;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasSourceId()) {
        output.writeInt32(1, getSourceId());
      }
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasMessageTime()) {
        output.writeInt32(3, getMessageTime());
      }
      if (hasIdleMax()) {
        output.writeInt32(101, getIdleMax());
      }
      if (hasAggrInterval()) {
        output.writeInt32(102, getAggrInterval());
      }
      for (ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData element : getBufferList()) {
        output.writeMessage(103, element);
      }
      if (hasConcentratedMassCenter()) {
        output.writeMessage(104, getConcentratedMassCenter());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasSourceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, getSourceId());
      }
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasMessageTime()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, getMessageTime());
      }
      if (hasIdleMax()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(101, getIdleMax());
      }
      if (hasAggrInterval()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(102, getAggrInterval());
      }
      for (ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData element : getBufferList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(103, element);
      }
      if (hasConcentratedMassCenter()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(104, getConcentratedMassCenter());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer result;
      
      // Construct using ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.buffer_ != java.util.Collections.EMPTY_LIST) {
          result.buffer_ =
            java.util.Collections.unmodifiableList(result.buffer_);
        }
        ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer other) {
        if (other == ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasIdleMax()) {
          setIdleMax(other.getIdleMax());
        }
        if (other.hasAggrInterval()) {
          setAggrInterval(other.getAggrInterval());
        }
        if (!other.buffer_.isEmpty()) {
          if (result.buffer_.isEmpty()) {
            result.buffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData>();
          }
          result.buffer_.addAll(other.buffer_);
        }
        if (other.hasConcentratedMassCenter()) {
          mergeConcentratedMassCenter(other.getConcentratedMassCenter());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 8: {
              setSourceId(input.readInt32());
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 24: {
              setMessageTime(input.readInt32());
              break;
            }
            case 808: {
              setIdleMax(input.readInt32());
              break;
            }
            case 816: {
              setAggrInterval(input.readInt32());
              break;
            }
            case 826: {
              ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.Builder subBuilder = ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addBuffer(subBuilder.buildPartial());
              break;
            }
            case 834: {
              ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.Builder subBuilder = ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.newBuilder();
              if (hasConcentratedMassCenter()) {
                subBuilder.mergeFrom(getConcentratedMassCenter());
              }
              input.readMessage(subBuilder, extensionRegistry);
              setConcentratedMassCenter(subBuilder.buildPartial());
              break;
            }
          }
        }
      }
      
      
      // required int32 sourceId = 1;
      public boolean hasSourceId() {
        return result.hasSourceId();
      }
      public int getSourceId() {
        return result.getSourceId();
      }
      public Builder setSourceId(int value) {
        result.hasSourceId = true;
        result.sourceId_ = value;
        return this;
      }
      public Builder clearSourceId() {
        result.hasSourceId = false;
        result.sourceId_ = 0;
        return this;
      }
      
      // optional int32 messageType = 2 [default = 521];
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 521;
        return this;
      }
      
      // required int32 messageTime = 3;
      public boolean hasMessageTime() {
        return result.hasMessageTime();
      }
      public int getMessageTime() {
        return result.getMessageTime();
      }
      public Builder setMessageTime(int value) {
        result.hasMessageTime = true;
        result.messageTime_ = value;
        return this;
      }
      public Builder clearMessageTime() {
        result.hasMessageTime = false;
        result.messageTime_ = 0;
        return this;
      }
      
      // optional int32 idleMax = 101;
      public boolean hasIdleMax() {
        return result.hasIdleMax();
      }
      public int getIdleMax() {
        return result.getIdleMax();
      }
      public Builder setIdleMax(int value) {
        result.hasIdleMax = true;
        result.idleMax_ = value;
        return this;
      }
      public Builder clearIdleMax() {
        result.hasIdleMax = false;
        result.idleMax_ = 0;
        return this;
      }
      
      // optional int32 aggrInterval = 102;
      public boolean hasAggrInterval() {
        return result.hasAggrInterval();
      }
      public int getAggrInterval() {
        return result.getAggrInterval();
      }
      public Builder setAggrInterval(int value) {
        result.hasAggrInterval = true;
        result.aggrInterval_ = value;
        return this;
      }
      public Builder clearAggrInterval() {
        result.hasAggrInterval = false;
        result.aggrInterval_ = 0;
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingBuffer.GpsData buffer = 103;
      public java.util.List<ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData> getBufferList() {
        return java.util.Collections.unmodifiableList(result.buffer_);
      }
      public int getBufferCount() {
        return result.getBufferCount();
      }
      public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData getBuffer(int index) {
        return result.getBuffer(index);
      }
      public Builder setBuffer(int index, ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.buffer_.set(index, value);
        return this;
      }
      public Builder setBuffer(int index, ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.Builder builderForValue) {
        result.buffer_.set(index, builderForValue.build());
        return this;
      }
      public Builder addBuffer(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.buffer_.isEmpty()) {
          result.buffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData>();
        }
        result.buffer_.add(value);
        return this;
      }
      public Builder addBuffer(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.Builder builderForValue) {
        if (result.buffer_.isEmpty()) {
          result.buffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData>();
        }
        result.buffer_.add(builderForValue.build());
        return this;
      }
      public Builder addAllBuffer(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData> values) {
        if (result.buffer_.isEmpty()) {
          result.buffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData>();
        }
        super.addAll(values, result.buffer_);
        return this;
      }
      public Builder clearBuffer() {
        result.buffer_ = java.util.Collections.emptyList();
        return this;
      }
      
      // optional .ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingBuffer.GpsData concentratedMassCenter = 104;
      public boolean hasConcentratedMassCenter() {
        return result.hasConcentratedMassCenter();
      }
      public ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData getConcentratedMassCenter() {
        return result.getConcentratedMassCenter();
      }
      public Builder setConcentratedMassCenter(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasConcentratedMassCenter = true;
        result.concentratedMassCenter_ = value;
        return this;
      }
      public Builder setConcentratedMassCenter(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.Builder builderForValue) {
        result.hasConcentratedMassCenter = true;
        result.concentratedMassCenter_ = builderForValue.build();
        return this;
      }
      public Builder mergeConcentratedMassCenter(ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData value) {
        if (result.hasConcentratedMassCenter() &&
            result.concentratedMassCenter_ != ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.getDefaultInstance()) {
          result.concentratedMassCenter_ =
            ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.newBuilder(result.concentratedMassCenter_).mergeFrom(value).buildPartial();
        } else {
          result.concentratedMassCenter_ = value;
        }
        result.hasConcentratedMassCenter = true;
        return this;
      }
      public Builder clearConcentratedMassCenter() {
        result.hasConcentratedMassCenter = false;
        result.concentratedMassCenter_ = ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.getDefaultInstance();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingBuffer)
    }
    
    static {
      defaultInstance = new GpsAggregatingBuffer(true);
      ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingBuffer)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingSettings_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingSettings_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_GpsData_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_GpsData_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\024GpsAggregating.proto\022/ru.omnicomm.pega" +
      "sus.messaging.settings.location\"\212\001\n\026GpsA" +
      "ggregatingSettings\022\020\n\010sourceId\030\001 \002(\005\022\030\n\013" +
      "messageType\030\002 \001(\005:\003520\022\023\n\013messageTime\030\003 " +
      "\002(\005\022\024\n\007idleMax\030e \001(\005:\003480\022\031\n\014aggrInterva" +
      "l\030f \001(\005:\003600\"\214\003\n\024GpsAggregatingBuffer\022\020\n" +
      "\010sourceId\030\001 \002(\005\022\030\n\013messageType\030\002 \001(\005:\00352" +
      "1\022\023\n\013messageTime\030\003 \002(\005\022\017\n\007idleMax\030e \001(\005\022" +
      "\024\n\014aggrInterval\030f \001(\005\022]\n\006buffer\030g \003(\0132M." +
      "ru.omnicomm.pegasus.messaging.settings.l",
      "ocation.GpsAggregatingBuffer.GpsData\022m\n\026" +
      "concentratedMassCenter\030h \001(\0132M.ru.omnico" +
      "mm.pegasus.messaging.settings.location.G" +
      "psAggregatingBuffer.GpsData\032>\n\007GpsData\022\016" +
      "\n\006dataId\030\001 \001(\005\022\020\n\010latitude\030\002 \001(\001\022\021\n\tlong" +
      "itude\030\003 \001(\001BO\n/ru.omnicomm.pegasus.messa" +
      "ging.settings.locationB\034GpsAggregatingSe" +
      "ttingsParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingSettings_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingSettings_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingSettings_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "IdleMax", "AggrInterval", },
              ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings.class,
              ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingSettings.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "IdleMax", "AggrInterval", "Buffer", "ConcentratedMassCenter", },
              ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.class,
              ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_GpsData_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_GpsData_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_location_GpsAggregatingBuffer_GpsData_descriptor,
              new java.lang.String[] { "DataId", "Latitude", "Longitude", },
              ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.class,
              ru.omnicomm.pegasus.messaging.settings.location.GpsAggregatingSettingsParser.GpsAggregatingBuffer.GpsData.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
